/*-
 * ~~~~~~licensing~~~~~~
 * resource-based-storage
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.integration.applications.storage.resource.impl;

import ru.entaxy.esb.resources.EntaxyResource;
import ru.entaxy.esb.resources.EntaxyResourceService;

public class ResourceContext {

    protected EntaxyResourceService entaxyResourceService;

    protected EntaxyResource rootResourceFolder;

    protected String rootResourceFolderUrl;

    protected ResourceContext parent = null;

    public ResourceContext() {
        super();
    }

    public ResourceContext(ResourceContext parent) {
        super();
        this.parent = parent;
    }

    public void init() {
        EntaxyResourceService resourceService = getEntaxyResourceService();
        if (resourceService != null)
            this.rootResourceFolder = resourceService.getResource(rootResourceFolderUrl);
    }

    public EntaxyResourceService getEntaxyResourceService() {
        if (entaxyResourceService != null)
            return entaxyResourceService;
        if (parent != null)
            return parent.getEntaxyResourceService();
        return null;
    }

    public void setEntaxyResourceService(EntaxyResourceService entaxyResourceService) {
        this.entaxyResourceService = entaxyResourceService;
    }

    public EntaxyResource getRootResourceFolder() {
        return rootResourceFolder;
    }

    public String getRootResourceFolderUrl() {
        return rootResourceFolderUrl;
    }

    public void setRootResourceFolderUrl(String rootResourceFolderUrl) {
        this.rootResourceFolderUrl = rootResourceFolderUrl;
    }

    public EntaxyResource getResource(String relPath) {
        String targetUrl = rootResourceFolderUrl;
        if (rootResourceFolderUrl.charAt(rootResourceFolderUrl.length() - 1) != '/')
            targetUrl = targetUrl.concat("/");
        if (relPath.charAt(0) == '/')
            targetUrl = targetUrl.concat(relPath.substring(1));
        else
            targetUrl = targetUrl.concat(relPath);
        EntaxyResource result = getEntaxyResourceService().getResource(targetUrl);
        return result;
    }

    public ResourceContext subcontext(String subPath) {
        ResourceContext result = new ResourceContext(this);
        result.setRootResourceFolderUrl(rootResourceFolderUrl.concat("/").concat(subPath));
        return result;
    }

}
